# Docker

Fluent Bit container images are available on Docker Hub ready for production usage. Current available images can be deployed in multiple architectures.

## Tags and Versions

The following table describes the tags that are available on Docker Hub [fluent/fluent-bit](https://hub.docker.com/r/fluent/fluent-bit/) repository:

| Tag(s)                  | Manifest Architectures    | Description                                                    |
| ----------------------- | ------------------------- | -------------------------------------------------------------- |
| 1.8, 1.8.15             | x86\_64, arm64v8, arm32v7 | Release [v1.8.15](https://fluentbit.io/announcements/v1.8.15/) |
| 1.8-debug, 1.8.15-debug | x86\_64                   | v1.8.x releases (production + debug)                           |
| 1.8.14                  | x86\_64, arm64v8, arm32v7 | Release [v1.8.14](https://fluentbit.io/announcements/v1.8.14/) |
| 1.8.14-debug            | x86\_64                   | v1.8.x releases (production + debug)                           |
| 1.8.13                  | x86\_64, arm64v8, arm32v7 | Release [v1.8.13](https://fluentbit.io/announcements/v1.8.13/) |
| 1.8.13-debug            | x86\_64                   | v1.8.x releases (production + debug)                           |
| 1.8.12                  | x86\_64, arm64v8, arm32v7 | Release [v1.8.12](https://fluentbit.io/announcements/v1.8.12/) |
| 1.8.12-debug            | x86\_64                   | v1.8.x releases (production + debug)                           |
| 1.8.11                  | x86\_64, arm64v8, arm32v7 | Release [v1.8.11](https://fluentbit.io/announcements/v1.8.11/) |
| 1.8.11-debug            | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.10                  | x86\_64, arm64v8, arm32v7 | Release [v1.8.10](https://fluentbit.io/announcements/v1.8.10/) |
| 1.8.10-debug            | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.9                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.9](https://fluentbit.io/announcements/v1.8.9/)   |
| 1.8.9-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.8                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.8](https://fluentbit.io/announcements/v1.8.8/)   |
| 1.8.8-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.7                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.7](https://fluentbit.io/announcements/v1.8.7/)   |
| 1.8.7-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.6                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.6](https://fluentbit.io/announcements/v1.8.6/)   |
| 1.8.6-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.5                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.5](https://fluentbit.io/announcements/v1.8.5/)   |
| 1.8.5-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.4                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.4](https://fluentbit.io/announcements/v1.8.4/)   |
| 1.8.4-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.3                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.3](https://fluentbit.io/announcements/v1.8.3/)   |
| 1.8.3-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.2                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.2](https://fluentbit.io/announcements/v1.8.2/)   |
| 1.8.2-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |
| 1.8.1                   | x86\_64, arm64v8, arm32v7 | Release [v1.8.1](https://fluentbit.io/announcements/v1.8.1/)   |
| 1.8.1-debug             | x86\_64                   | v1.8.x releases + Busybox                                      |

It's strongly suggested that you always use the latest image of Fluent Bit.

## Multi Architecture Images

Our x86\_64 stable image is based on [Distroless](https://github.com/GoogleContainerTools/distroless) focusing on security containing just the Fluent Bit binary and minimal system libraries and basic configuration. Optionally, we provide **debug** images for x86\_64 which contain a full shell and package manager that can be used to troubleshoot or for testing purposes.

In addition, the main manifest provides images for arm64v8 and arm32v7 architectures. From a deployment perspective, there is no need to specify an architecture, the container client tool that pulls the image gets the proper layer for the running architecture.

For every architecture we build the layers using the following base images:

| Architecture | Base Image                                                       |
| ------------ | ---------------------------------------------------------------- |
| x86\_64      | [Distroless](https://github.com/GoogleContainerTools/distroless) |
| arm64v8      | arm64v8/debian:bullseye-slim                                     |
| arm32v7      | arm32v7/debian:bullseye-slim                                     |

## Getting Started

Download the last stable image from 1.8 series:

```
docker pull fluent/fluent-bit:1.8
```

Once the image is in place, now run the following (useless) test which makes Fluent Bit measure CPU usage by the container:

```
docker run -ti fluent/fluent-bit:1.8 /fluent-bit/bin/fluent-bit -i cpu -o stdout -f 1
```

That command will let Fluent Bit measure CPU usage every second and flush the results to the standard output, e.g:

```
Fluent-Bit v1.8.x
Copyright (C) Treasure Data

[2019/10/01 12:29:02] [ info] [engine] started
[0] cpu.0: [1504290543.000487750, {"cpu_p"=>0.750000, "user_p"=>0.250000, "system_p"=>0.500000, "cpu0.p_cpu"=>0.000000, "cpu0.p_user"=>0.000000, "cpu0.p_system"=>0.000000, "cpu1.p_cpu"=>1.000000, "cpu1.p_user"=>0.000000, "cpu1.p_system"=>1.000000, "cpu2.p_cpu"=>1.000000, "cpu2.p_user"=>1.000000, "cpu2.p_system"=>0.000000, "cpu3.p_cpu"=>0.000000, "cpu3.p_user"=>0.000000, "cpu3.p_system"=>0.000000}]
```

## F.A.Q

### Why there is no Fluent Bit Docker image based on Alpine Linux ?

Alpine Linux uses Musl C library instead of Glibc. Musl is not fully compatible with Glibc which generated many issues in the following areas when used with Fluent Bit:

* Memory Allocator: to run Fluent Bit properly in high-load environments, we use Jemalloc as a default memory allocator which reduce fragmentation and provides better performance for our needs. Jemalloc cannot run smoothly with Musl and requires extra work.
* Alpine Linux Musl functions bootstrap have a compatibility issue when loading Golang shared libraries, this generate problems when trying to load Golang output plugins in Fluent Bit.
* Alpine Linux Musl Time format parser does not support Glibc extensions
* Maintainers preference in terms of base image due to security and maintenance reasons are Distroless and Debian.

### Where 'latest' Tag points to ?

Our Docker containers images are deployed thousands of times per day, we take security and stability very seriously.

The *latest* tag *most of the time* points to the latest stable image. When we release a major update to Fluent Bit like for example from v1.3.x to v1.4.0, we don't move *latest* tag until 2 weeks after the release. That give us extra time to verify with our community that everything works as expected.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fluentbit.io/manual/1.8/installation/docker.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
